RepWatch = LibStub("AceAddon-3.0"):NewAddon("RepWatch", "AceEvent-3.0", "AceConsole-3.0")


-------------------------------------
-- By Seglberg (Dragonspew) on THRALL (PST ME IF NEED BE)
--
-- Future Additions and Improvments:
-- Add Options to Allow Which Places will AutoChange, Like Instances, Battlegrounds, Non-Instances, Cities...
-- Ability to stop the Bar from changing if you are already exalted with that faction
-- Sub-zone Support
------------------------------------- 


RepWatch.Version = "1.0.4 (RC3)"

local options = {
    name = "RepWatch",
    handler = RepWatch,
    type = 'group',
    args = {
	changeOptionsDescription = {
		order = 1,
		type = "description",
		name = "_____ Auto-Changing Options ______________________",
		cmdHidden = true,
		},
	otherOptionsDescription = {
		order = 10,
		type = "description",
		name = "_____ Other Options _______________________________",
		cmdHidden = true,
		},
	versionDescription = {
		order = 100,
		type = "description",
		name = "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n|cffFF7F24Version: 1.0.4 (RC3)|r",
		cmdHidden = true,
		},
	showInChat = {
			order = 11,
          	  type = "toggle",
         	   name = "Display Notice",
         	   desc = "Displays a Notice in the Chatbox When the Watched Faction is changed (Default: On)",
         	   get = "IsShowInChat",
         	   set = "ToggleShowInChat",
        },
	changeIfExalted = {
		order = 12,
           	type = "toggle",
          	name = "Change If Exalted",
		desc = "Not Available Yet, Future Improvment",
          	--desc = "Enabling this will change the Reputation Bar to the correct faction even if fully Exalted (Default: Off)",
         	get = "IsChangeIfExalted",
         	set = "ToggleChangeIfExalted",
        },
	changeInBCInstance = {
		order = 2,
		type = "toggle",
		name = "BC Instances",
		desc = "Toggle this on/off to Enable or Disable the Changing of the Rep Bar when you Zone into an Burning Crusade Instance (Default: On)",
		get = "IsChangeInBCInstance",
		set = "ToggleChangeInBCInstance",
		},
	changeInClassicInstance = {
		order = 3,
		type = "toggle",
		name = "Classic Instances",
		desc = "Not Available Yet, Future Improvment",
		--desc = "Toggle this on/off to Enable or Disable the Changing of the Rep Bar when you Zone into a Classic World of Warcraft Instance (Default: On)",
		get = "IsChangeInClassicInstance",
		set = "ToggleChangeInClassicInstance",
		},
	changeInCities = {
		order = 4,
		type = "toggle",
		name = "In Cities",
		desc = "Toggle this on/off to Enable or Disable the Changing of the Rep Bar when you Enter a Capital City (Default: On)",
		get = "IsChangeInCities",
		set = "ToggleChangeInCities",
		},
	changeInBGs = {
		order = 5,
		type = "toggle",
		name = "In Battlegrounds",
		desc = "Toggle this on/off to Enable or Disable the Changing of the Rep Bar when you Enter a Battleground (Default: On)",
		get = "IsChangeInBGs",
		set = "ToggleChangeInBGs",
		},
	
    },
}

local defaults = {
	char = {
		showInChat = true,
		changeInBCInstance = true,
		changeInCities = true,
		changeInClassicInstance = false,
		changeInBGs = true,
		changeIfExalted = false,
	},
}






-------------------------------------
function RepWatch:OnInitialize()
	-- Called When the Addon is Loaded


	-- Register the Database
	RepWatch.db = LibStub("AceDB-3.0"):New("RepWatchDB", defaults, "Char")

	LibStub("AceConfig-3.0"):RegisterOptionsTable("RepWatch", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("RepWatch", "RepWatch")
	self:RegisterChatCommand("RepWatch", "ChatCommand")

	


end
-------------------------------------
-------------------------------------
function RepWatch:OnEnable()
	RepWatch:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	RepWatch:RegisterEvent("ZONE_CHANGED")
	self:Print("RepWatch Ver.|cffFF7F24", RepWatch.Version, "|rLoaded")
	self:Print("Type /RepWatch for Options")
	
	RepWatch:ZONE_CHANGED_NEW_AREA()	
end
-------------------------------------
-------------------------------------
function RepWatch:OnDisable()
	-- Called when the Addon is Disabled
end
-------------------------------------
-------------------------------------
function RepWatch:ChatCommand(input)
	-- Handles Chat Command Input


	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToFrame(self.optionsFrame)
	else
		LibStub("AceConfigDialog-3.0").HandleCommand(RepWatch, "RepWatch", input)
	end
end
-------------------------------------
-------------------------------------
function RepWatch:IsShowInChat(info)
 	return self.db.char.showInChat
end
-------------------------------------
-------------------------------------

function RepWatch:ToggleShowInChat(info, value)
	self.db.char.showInChat = value
	if self.db.char.showInChat then
		self:Print("Changes |cff32cd32Will Now|r Be Announced in Your Chat Window")
	else
		self:Print("Changes |cffff0000Will Not|r Be Announced in Your Chat Window")
	end
	
end
-------------------------------------
-------------------------------------
function RepWatch:IsChangeInBCInstance(info)
	return self.db.char.changeInBCInstance
end
-------------------------------------
-------------------------------------
function RepWatch:ToggleChangeInBCInstance(info, value)
	self.db.char.changeInBCInstance = value
	if self.db.char.changeInBCInstance then
		self:Print("The Rep Bar |cff32cd32Will Now|r Change when you Zone Into Burning Crusade Instances")
	else
		self:Print("The Rep Bar |cffff0000Will Not|r Change when you Zone Into Burning Crusade Instances")
	end
end
-------------------------------------
-------------------------------------
function RepWatch:IsChangeInCities(info)
	return self.db.char.changeInCities
end
-------------------------------------
-------------------------------------
function RepWatch:ToggleChangeInCities(info, value)
	self.db.char.changeInCities = value
	if self.db.char.changeInCities then
		self:Print("The Rep Bar |cff32cd32Will Now|r Change when you Enter a Capital City")
	else
		self:Print("The Rep Bar |cffff0000Will Not|r Change when you Enter a Capital City")
		--self:Print("This Feature Is Still Under Development, Please Check for Mod Updates!")
	end
end
-------------------------------------
-------------------------------------
function RepWatch:IsChangeInClassicInstance(info)
	return self.db.char.changeInClassicInstance
end
-------------------------------------
-------------------------------------
function RepWatch:ToggleChangeInClassicInstance(info, value)
	self.db.char.changeInClassicInstance = false
	if self.db.char.changeInClassicInstance then
		self:Print("The Rep Bar |cff32cd32Will Now|r Change when you Enter a Classic WoW Instance")
	else
		--self:Print("The Rep Bar |cffff0000Will Not|r Change when you Enter a Classic WoW Instance")
		self:Print("This Feature Is Under Development, Set to Release with RepWatch v1.1!")
	end
end
-------------------------------------
-------------------------------------
function RepWatch:IsChangeInBGs(info)
	return self.db.char.changeInBGs
end
-------------------------------------
-------------------------------------
function RepWatch:ToggleChangeInBGs(info, value)
	self.db.char.changeInBGs = value
	if self.db.char.changeInBGs then
		self:Print("The Rep Bar |cff32cd32Will Now|r Change when you Enter a Battleground")
	else
		self:Print("The Rep Bar |cffff0000Will Not|r Change when you Enter a Battleground")
		--self:Print("This Feature Is Still Under Development, Please Check for Mod Updates!")
	end
end
-------------------------------------
-------------------------------------
function RepWatch:IsChangeIfExalted(info)
	return self.db.char.changeIfExalted
end
-------------------------------------
-------------------------------------
function RepWatch:ToggleChangeIfExalted(info, value)
	self.db.char.changeIfExalted = false
	if self.db.char.changeIfExalted then
		self:Print("The Rep Bar |cff32cd32Will Now|r Change when you Enter a Classic WoW Instance")
	else
		--self:Print("The Rep Bar |cffff0000Will Not|r Change when you Enter a Classic WoW Instance")
		self:Print("This Feature Is Under Development, Set to Release with RepWatch v1.1!")
	end
end
-------------------------------------
-------------------------------------








--Handlers Below:
-------------------------------------
-------------------------------------
function RepWatch:ZONE_CHANGED_NEW_AREA()

	if self.db.char.changeInBCInstance then
		RepWatch:BCInstanceChange()	
	end

	if self.db.char.changeInCities then
		RepWatch:CityChange()
	end
	
	if self.db.char.changeInBGs then
		RepWatch:BGChange()
	end
	
	
	
	self.watchname = GetWatchedFactionInfo()
	if (self.db.char.showInChat) and (self.Zonerep ~= nil) and (self.Zonerep ~= self.watchname) then
		self:Print("Watched Faction Just Changed To:", "|cffFF4500", self.Zonerep, "|r")
	end

	
	
end
-------------------------------------
-------------------------------------
function RepWatch:BCInstanceChange()
--This function handles the finding and switching the watched faction bar for BC Instances
	----------------
	--Isle of Quel'Danas Instances
	----------------
	if GetRealZoneText() == "Magisters' Terrace" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Shattered Sun Offensive"
	end
	if GetRealZoneText() == "Sunwell Plateau" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Shattered Sun Offensive"
	end
	----------------
	-- Caverns of Time Instances
	----------------
	if GetRealZoneText() == "Old Hillsbrad Foothills" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Keepers of Time"
	end
	if GetRealZoneText() == "The Black Morass" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Keepers of Time"
	end
	if GetRealZoneText() == "Hyjal Summit" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Scales of the Sand"
	end
	----------------
	--Auchindoun Instances
	----------------
	if GetRealZoneText() == "Mana-Tombs" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "The Consortium"
	end
	if GetRealZoneText() == "Auchenai Crypts" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Lower City"
	end
	if GetRealZoneText() == "Sethekk Halls" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Lower City"
	end
	if GetRealZoneText() == "Shadow Labyrinth" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Lower City"
	end
	----------------
	--Cenarion Expediton Instances
	----------------
	if GetRealZoneText() == "The Slave Pens" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Cenarion Expedition"
	end
	if GetRealZoneText() == "The Underbog" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Cenarion Expedition"
	end
	if GetRealZoneText() == "The Steamvault" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Cenarion Expedition"
	end
	if GetRealZoneText() == "Serpentshrine Cavern" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Cenarion Expedition"
	end
	----------------
	--Tempest Keep Instances
	----------------
	if GetRealZoneText() == "The Mechanar" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "The Sha'tar"
	end 
	if GetRealZoneText() == "The Botanica" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "The Sha'tar"
	end 
	if GetRealZoneText() == "The Arcatraz" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "The Sha'tar"
	end 
	----------------
	--Hellfire Instances
	----------------
	if GetRealZoneText() == "The Blood Furnace" then
		self.currentLocation = GetRealZoneText()
		if UnitFactionGroup("player") == "Horde" then
			self.Zonerep = "Thrallmar"
		else
			self.Zonerep = "Honor Hold"
		end
	end 
	if GetRealZoneText() == "Hellfire Ramparts" then
		self.currentLocation = GetRealZoneText()
		if UnitFactionGroup("player") == "Horde" then
			self.Zonerep = "Thrallmar"
		else
			self.Zonerep = "Honor Hold"
		end
	end 
	if GetRealZoneText() == "The Shattered Halls" then
		self.currentLocation = GetRealZoneText()
		if UnitFactionGroup("player") == "Horde" then
			self.Zonerep = "Thrallmar"
		else
			self.Zonerep = "Honor Hold"
		end
	end 
	----------------
	--Standalone Instances
	----------------
	if GetRealZoneText() == "Karazhan" then
		self.Zonerep = "The Violet Eye"
	end
	--------
	if GetRealZoneText() == "Black Temple" then
		self.Zonerep = "Ashtongue Deathsworn"
	end
	--------


	--Sets the Watched Faction
	for factionIndex = 1, GetNumFactions() do
		self.factionName = GetFactionInfo(factionIndex)
		if self.factionName == self.Zonerep then
			SetWatchedFactionIndex(factionIndex)
		end
	end	
end	
-------------------------------------
-------------------------------------
function RepWatch:CityChange()
	----------------
	--Horde Capitals
	----------------
	if GetRealZoneText() == "Orgrimmar" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Orgrimmar"
	end
	if GetRealZoneText() == "Undercity" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Undercity"
	end
	if GetRealZoneText() == "Silvermoon City" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Silvermoon City"
	end
	if GetRealZoneText() == "Thunder Bluff" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Thunder Bluff"
	end
	----------------
	--Alliance Capitals
	----------------
	if GetRealZoneText() == "Stormwind City" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Stormwind City"
	end
	if GetRealZoneText() == "Ironforge" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Ironforge"
	end
	if GetRealZoneText() == "The Exodar" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "The Exodar"
	end
	if GetRealZoneText() == "Darnassus" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Darnassus"
	end
	----------------
	--Neutral Capitals
	----------------
	if GetRealZoneText() == "Shattrath City" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "The Sha'tar"
	end
	if GetRealZoneText() == "Booty Bay" then
		self.currentLocation = GetRealZoneText()
		self.Zonerep = "Booty Bay"
	end


	--Sets the Watched Faction
	for factionIndex = 1, GetNumFactions() do
		self.factionName = GetFactionInfo(factionIndex)
		if self.factionName == self.Zonerep then
			SetWatchedFactionIndex(factionIndex)
		end
	end
end
-------------------------------------
-------------------------------------
function RepWatch:BGChange()
	----------------
	--Horde Battlegrounds
	----------------
	if UnitFactionGroup("player") == "Horde" then
		if GetRealZoneText() == "Warsong Gulch" then
			self.currentLocation = GetRealZoneText()
			self.Zonerep = "Warsong Outriders"
		end
		if GetRealZoneText() == "Arathi Basin" then
			self.currentLocation = GetRealZoneText()
			self.Zonerep = "The Defilers"
		end
		if GetRealZoneText() == "Alterac Valley" then
			self.currentLocation = GetRealZoneText()
			self.Zonerep = "Frostwolf Clan"
		end
	
	----------------
	--Alliance Battlegrounds
	----------------
	else
		if GetRealZoneText() == "Warsong Gulch" then
			self.currentLocation = GetRealZoneText()
			self.Zonerep = "Silverwing Sentinels"
		end
		if GetRealZoneText() == "Arathi Basin" then
			self.currentLocation = GetRealZoneText()
			self.Zonerep = "The League of Arathor"
		end
		if GetRealZoneText() == "Alterac Valley" then
			self.currentLocation = GetRealZoneText()
			self.Zonerep = "Stormpike Guard"
		end
	end
	
	--Sets the Watched Faction
	for factionIndex = 1, GetNumFactions() do
		self.factionName = GetFactionInfo(factionIndex)
		if self.factionName == self.Zonerep then
			SetWatchedFactionIndex(factionIndex)
		end
	end
	
end
-------------------------------------
-------------------------------------
function RepWatch:ZONE_CHANGED()
	RepWatch:ZONE_CHANGED_NEW_AREA()
end
-------------------------------------
-------------------------------------
	
